/*
    PicProbe for Sharp Linux Zaurus
    Copyright (C) 2005  NODA Atsushi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <qwidget.h>
#include <qpixmap.h>

class ImageWindows : public QWidget
{
 public:
  ImageWindows( QWidget *parent=0, const char *name=0, WFlags f=0);
  void clearImage();
  void flush();
  void dspCenter(const QString &);
  bool dspData(bool flgD,const unsigned int * adata,const bool * flgAD);

 protected:
  virtual void paintEvent( QPaintEvent*);
  virtual void resizeEvent( QResizeEvent*);
 private:
  QPixmap _buffer;
};

const int noOfBuf = 16;

class MainForm : public QWidget {
  Q_OBJECT
 public:
  MainForm();
  ~MainForm();
 private:
  ImageWindows* imageWindows;
  QTimer * internalTimer;
  int fd;
  unsigned char dataBuf[noOfBuf];
  int pDataBuf;
  bool getData();
  void dspDataClear();
  void dspDataSet(const unsigned char *,int);
  bool dspData();

 private slots:
  void timeout();
};

extern MainForm *mainForm;
